// lbg@dongseo.ac.kr 2014.1.16
int   n = 11;
float pushBack = 0;
float rotationX = 0;
float rotationY = 0;
float velocityX = 0;
float velocityY = 0;
float speed = 0.1;
float ratio = 0.8;
boolean lineflag = false;

TexturedTriangle tT;

void setup() {
  size(800, 600, P3D);  
  tT = new TexturedTriangle();
  smooth();
  textureMode(NORMAL); 
  strokeWeight(2);
  lights();    
}

void keyPressed() {
  if(key=='1') speed-=0.1;
  else if(key=='2') speed+=0.1;
  else if(key=='3') { 
    n--;
    tT.setColumn(n, ratio);
  }  
  else if(key=='4') {
    n++;
    tT.setColumn(n, ratio);
  }
  else if(key=='5') { 
    ratio-=0.05;
    tT.setColumn(n, ratio);
  }  
  else if(key=='6') {
    ratio+=0.05;
    tT.setColumn(n, ratio);
  }
  else if(key=='7') pushBack-=10;
  else if(key=='8') pushBack+=10;  
  else if(key=='z') lineflag=!lineflag;
  println("speed:"+speed+" column:"+n+" ratio:"+ratio+" flag:"+lineflag);
}

void draw() {    
  background(0);      
  if(!lineflag) noStroke();
  else stroke(255);
  renderTriangle(); 
  update();
}

void renderTriangle() {
  pushMatrix();
  translate(width * 0.5, height * 0.5, pushBack);
  rotateX(radians(-rotationX) );  
  rotateY(radians(270 - rotationY) );
  tT.update(speed);
  tT.draw();
  popMatrix();
}

void update() {
  rotationX += velocityX;
  rotationY += velocityY;
  velocityX *= 0.95;
  velocityY *= 0.95;
  if(mousePressed) {
    velocityX += (mouseY-pmouseY) * 0.01;
    velocityY -= (mouseX-pmouseX) * 0.01;
  }
  else {
    rotationX -= rotationX*0.025;
    rotationY -= rotationY*0.025;
  }  
}


