class TexturedTriangle {
  int   twidth, theight, n;
  float theta;
  PImage [] texmap;
  
  TexturedTriangle() {
    setColumn(11, 0.8);
    texmap = new PImage[3];
    texmap[0] = loadImage("coca.jpg");        
    texmap[1] = loadImage("hp.jpg");        
    texmap[2] = loadImage("galaxy3.jpg");        
  }
  
  void setColumn(int n, float r) {
    this.n=n;
    twidth=(int)(width*r/n);
    theight=(int)(height*r);
  }

  void update(float delta) {
    theta+=delta;
  }
  
  void draw() {
    for(int i=0; i<n; i++) {
      pushMatrix();
      translate(0,0,-twidth*(n/2-i));
      drawTriangle(i);
      popMatrix();
    }  
  }
  
  void drawTriangle(int i) {
    int j;
    rotateY(radians(theta));
    line(0, -theight, 0, 0, theight, 0);
    beginShape(QUADS);
    texture(texmap[0]);
    vertex(-twidth/2, -theight/2, 0, 1.-(float)i/n, 0);
    vertex(twidth/2, -theight/2, 0, 1.-(i+1.)/n, 0);
    vertex(twidth/2, theight/2, 0, 1.-(i+1.)/n, 1.);
    vertex(-twidth/2, theight/2, 0, 1.-(float)i/n, 1.);
    endShape();   

    beginShape(QUADS);
    texture(texmap[1]);
    j=n-i-1;
    vertex(-twidth/2, -theight/2, 0, (float)j/n, 0);
    vertex(0, -theight/2, twidth*sqrt(3)/2, (j+1.)/n, 0);
    vertex(0, theight/2, twidth*sqrt(3)/2, (j+1.)/n, 1.);
    vertex(-twidth/2, theight/2, 0, (float)j/n, 1.);
    endShape();   
    
    beginShape(QUADS);
    texture(texmap[2]);
    vertex(0, -theight/2, twidth*sqrt(3)/2, (float)(j+0.)/n, 0);
    vertex(twidth/2, -theight/2, 0, (float)(j+1.)/n, 0);
    vertex(twidth/2, theight/2, 0, (float)(j+1.)/n, 1.);
    vertex(0, theight/2, twidth*sqrt(3)/2, (float)(j+0.)/n, 1.);
    endShape();   
  }
}

  
  

  
  
  
  
